## GstAdapter GstAdapter — adapts incoming data on a sink pad into chunks of N bytes |

## Functions

GstAdapter * | gst_adapter_new ()
void | gst_adapter_clear ()
void | gst_adapter_push ()
gconstpointer | gst_adapter_map ()
void | gst_adapter_unmap ()
void | gst_adapter_copy ()
GBytes * | gst_adapter_copy_bytes ()
void | gst_adapter_flush ()
gsize | gst_adapter_available ()
gsize | gst_adapter_available_fast ()
gpointer | gst_adapter_take ()
GstBuffer * | gst_adapter_take_buffer ()
GstBuffer * | gst_adapter_get_buffer ()
GstBuffer * | gst_adapter_take_buffer_fast ()
GstBuffer * | gst_adapter_get_buffer_fast ()
GList * | gst_adapter_take_list ()
GList * | gst_adapter_get_list ()
GstBufferList * | gst_adapter_take_buffer_list ()
GstBufferList * | gst_adapter_get_buffer_list ()
GstClockTime | gst_adapter_prev_pts ()
GstClockTime | gst_adapter_prev_dts ()
GstClockTime | gst_adapter_prev_pts_at_offset ()
GstClockTime | gst_adapter_prev_dts_at_offset ()
gssize | gst_adapter_masked_scan_uint32 ()
gssize | gst_adapter_masked_scan_uint32_peek ()

## Types and Values

| GstAdapter

## Object Hierarchy

        GObject
        ╰── GstAdapter

## Includes

    #include <gst/base/gstadapter.h>

## Description

This class is for elements that receive buffers in an undesired size. While for example raw video contains one image per buffer, the same is not true for a lot of other formats, especially those that come directly from a file. So if you have undefined buffer sizes and require a specific size, this object is for you.

An adapter is created with `gst_adapter_new()`. It can be freed again with `g_object_unref()`.

The theory of operation is like this: All buffers received are put into the adapter using `gst_adapter_push()` and the data is then read back in chunks of the desired size using `gst_adapter_map()`/`gst_adapter_unmap()` and/or `gst_adapter_copy()`. After the data has been processed, it is freed using `gst_adapter_unmap()`.

Other methods such as `gst_adapter_take()` and `gst_adapter_take_buffer()` combine `gst_adapter_map()` and `gst_adapter_unmap()` in one method and are potentially more convenient for some use cases.

For example, a sink pad's chain function that needs to pass data to a library in 512-byte chunks could be implemented like this:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    static GstFlowReturn
    sink_pad_chain (GstPad *pad, GstObject *parent, GstBuffer *buffer)
    {
      MyElement *this;
      GstAdapter *adapter;
      GstFlowReturn ret = GST_FLOW_OK;

      this = MY_ELEMENT (parent);

      adapter = this->adapter;

      // put buffer into adapter
      gst_adapter_push (adapter, buffer);

      // while we can read out 512 bytes, process them
      while (gst_adapter_available (adapter) >= 512 && ret == GST_FLOW_OK) {
        const guint8 *data = gst_adapter_map (adapter, 512);
        // use flowreturn as an error value
        ret = my_library_foo (data);
        gst_adapter_unmap (adapter);
        gst_adapter_flush (adapter, 512);
      }
      return ret;
    }

For another example, a simple element inside GStreamer that uses GstAdapter is the libvisual element.

An element using GstAdapter in its sink pad chain function should ensure that when the FLUSH_STOP event is received, that any queued data is cleared using `gst_adapter_clear()`. Data should also be cleared or processed on EOS and when changing state from `GST_STATE_PAUSED` to `GST_STATE_READY`.

Also check the GST_BUFFER_FLAG_DISCONT flag on the buffer. Some elements might need to clear the adapter after a discontinuity.

The adapter will keep track of the timestamps of the buffers that were pushed. The last seen timestamp before the current position can be queried with `gst_adapter_prev_pts()`. This function can optionally return the number of bytes between the start of the buffer that carried the timestamp and the current adapter position. The distance is useful when dealing with, for example, raw audio samples because it allows you to calculate the timestamp of the current adapter position by using the last seen timestamp and the amount of bytes since. Additionally, the `gst_adapter_prev_pts_at_offset()` can be used to determine the last seen timestamp at a particular offset in the adapter.

A last thing to note is that while GstAdapter is pretty optimized, merging buffers still might be an operation that requires a `malloc()` and `memcpy()` operation, and these operations are not the fastest. Because of this, some functions like `gst_adapter_available_fast()` are provided to help speed up such cases should you want to. To avoid repeated memory allocations, `gst_adapter_copy()` can be used to copy data into a (statically allocated) user provided buffer.

GstAdapter is not MT safe. All operations on an adapter must be serialized by the caller. This is not normally a problem, however, as the normal use case of GstAdapter is inside one pad's chain function, in which case access is serialized via the pad's STREAM_LOCK.

Note that `gst_adapter_push()` takes ownership of the buffer passed. Use `gst_buffer_ref()` before pushing it into the adapter if you still want to access the buffer later. The adapter will never modify the data in the buffer pushed in it.

## Functions

### gst_adapter_new ()

    GstAdapter *
    gst_adapter_new (void);

Creates a new GstAdapter. Free with `g_object_unref()`.

#### Returns

a new GstAdapter.

[transfer full]

### gst_adapter_clear ()

    void
    gst_adapter_clear (GstAdapter *adapter);

Removes all buffers from `adapter` .

#### Parameters

adapter | a GstAdapter |

### gst_adapter_push ()

    void
    gst_adapter_push (GstAdapter *adapter,
                      GstBuffer *buf);

Adds the data from `buf` to the data stored inside `adapter` and takes ownership of the buffer.

#### Parameters

adapter | a GstAdapter |
buf | a GstBuffer to add to queue in the adapter. | [transfer full]

### gst_adapter_map ()

    gconstpointer
    gst_adapter_map (GstAdapter *adapter,
                     gsize size);

Gets the first `size` bytes stored in the `adapter` . The returned pointer is valid until the next function is called on the adapter.

Note that setting the returned pointer as the data of a GstBuffer is incorrect for general-purpose plugins. The reason is that if a downstream element stores the buffer so that it has access to it outside of the bounds of its chain function, the buffer will have an invalid data pointer after your element flushes the bytes. In that case you should use `gst_adapter_take()`, which returns a freshly-allocated buffer that you can set as GstBuffer memory or the potentially more performant `gst_adapter_take_buffer()`.

Returns `NULL` if `size` bytes are not available.

#### Parameters

adapter | a GstAdapter |
size | the number of bytes to map/peek |

#### Returns

a pointer to the first `size` bytes of data, or `NULL`.

[transfer none][array length=size][element-type guint8][nullable]

### gst_adapter_unmap ()

    void
    gst_adapter_unmap (GstAdapter *adapter);

Releases the memory obtained with the last `gst_adapter_map()`.

#### Parameters

adapter | a GstAdapter |

### gst_adapter_copy ()

    void
    gst_adapter_copy (GstAdapter *adapter,
                      gpointer dest,
                      gsize offset,
                      gsize size);

Copies `size` bytes of data starting at `offset` out of the buffers contained in GstAdapter into an array `dest` provided by the caller.

The array `dest` should be large enough to contain `size` bytes. The user should check that the adapter has (`offset` + `size` ) bytes available before calling this function.

[skip]

#### Parameters

adapter | a GstAdapter |
dest | the memory to copy into. | [out caller-allocates][array length=size][element-type guint8]
offset | the bytes offset in the adapter to start from |
size | the number of bytes to copy |

### gst_adapter_copy_bytes ()

    GBytes *
    gst_adapter_copy_bytes (GstAdapter *adapter,
                            gsize offset,
                            gsize size);

Similar to gst_adapter_copy, but more suitable for language bindings. `size` bytes of data starting at `offset` will be copied out of the buffers contained in `adapter` and into a new GBytes structure which is returned. Depending on the value of the `size` argument an empty GBytes structure may be returned.

[rename-to gst_adapter_copy]

#### Parameters

adapter | a GstAdapter |
offset | the bytes offset in the adapter to start from |
size | the number of bytes to copy |

#### Returns

A new GBytes structure containing the copied data.

[transfer full]

Since: 1.4

### gst_adapter_flush ()

    void
    gst_adapter_flush (GstAdapter *adapter,
                       gsize flush);

Flushes the first `flush` bytes in the `adapter` . The caller must ensure that at least this many bytes are available.

See also: `gst_adapter_map()`, `gst_adapter_unmap()`

#### Parameters

adapter | a GstAdapter |
flush | the number of bytes to flush |

### gst_adapter_available ()

    gsize
    gst_adapter_available (GstAdapter *adapter);

Gets the maximum amount of bytes available, that is it returns the maximum value that can be supplied to `gst_adapter_map()` without that function returning `NULL`.

#### Parameters

adapter | a GstAdapter |

#### Returns

number of bytes available in `adapter`

### gst_adapter_available_fast ()

    gsize
    gst_adapter_available_fast (GstAdapter *adapter);

Gets the maximum number of bytes that are immediately available without requiring any expensive operations (like copying the data into a temporary buffer).

#### Parameters

adapter | a GstAdapter |

#### Returns

number of bytes that are available in `adapter` without expensive operations

### gst_adapter_take ()

    gpointer
    gst_adapter_take (GstAdapter *adapter,
                      gsize nbytes);

Returns a freshly allocated buffer containing the first `nbytes` bytes of the `adapter` . The returned bytes will be flushed from the adapter.

Caller owns returned value. g_free after usage.

Free-function: g_free

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to take |

#### Returns

oven-fresh hot data, or `NULL` if `nbytes` bytes are not available.

[transfer full][array length=nbytes][element-type guint8][nullable]

### gst_adapter_take_buffer ()

    GstBuffer *
    gst_adapter_take_buffer (GstAdapter *adapter,
                             gsize nbytes);

Returns a GstBuffer containing the first `nbytes` bytes of the `adapter` . The returned bytes will be flushed from the adapter. This function is potentially more performant than `gst_adapter_take()` since it can reuse the memory in pushed buffers by subbuffering or merging. This function will always return a buffer with a single memory region.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

Since 1.6 this will also copy over all GstMeta of the input buffers except for meta with the `GST_META_FLAG_POOLED` flag or with the "memory" tag.

Caller owns a reference to the returned buffer. `gst_buffer_unref()` after usage.

Free-function: gst_buffer_unref

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to take |

#### Returns

a GstBuffer containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available. `gst_buffer_unref()` when no longer needed.

[transfer full][nullable]

### gst_adapter_get_buffer ()

    GstBuffer *
    gst_adapter_get_buffer (GstAdapter *adapter,
                            gsize nbytes);

Returns a GstBuffer containing the first `nbytes` of the `adapter` , but does not flush them from the adapter. See `gst_adapter_take_buffer()` for details.

Caller owns a reference to the returned buffer. `gst_buffer_unref()` after usage.

Free-function: gst_buffer_unref

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to get |

#### Returns

a GstBuffer containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available. `gst_buffer_unref()` when no longer needed.

[transfer full][nullable]

Since: 1.6

### gst_adapter_take_buffer_fast ()

    GstBuffer *
    gst_adapter_take_buffer_fast (GstAdapter *adapter,
                                  gsize nbytes);

Returns a GstBuffer containing the first `nbytes` of the `adapter` . The returned bytes will be flushed from the adapter. This function is potentially more performant than `gst_adapter_take_buffer()` since it can reuse the memory in pushed buffers by subbuffering or merging. Unlike `gst_adapter_take_buffer()`, the returned buffer may be composed of multiple non-contiguous GstMemory objects, no copies are made.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

This will also copy over all GstMeta of the input buffers except for meta with the `GST_META_FLAG_POOLED` flag or with the "memory" tag.

This function can return buffer up to the return value of `gst_adapter_available()` without making copies if possible.

Caller owns a reference to the returned buffer. `gst_buffer_unref()` after usage.

Free-function: gst_buffer_unref

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to take |

#### Returns

a GstBuffer containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available. `gst_buffer_unref()` when no longer needed.

[transfer full][nullable]

Since: 1.2

### gst_adapter_get_buffer_fast ()

    GstBuffer *
    gst_adapter_get_buffer_fast (GstAdapter *adapter,
                                 gsize nbytes);

Returns a GstBuffer containing the first `nbytes` of the `adapter` , but does not flush them from the adapter. See `gst_adapter_take_buffer_fast()` for details.

Caller owns a reference to the returned buffer. `gst_buffer_unref()` after usage.

Free-function: gst_buffer_unref

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to get |

#### Returns

a GstBuffer containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available. `gst_buffer_unref()` when no longer needed.

[transfer full][nullable]

Since: 1.6

### gst_adapter_take_list ()

    GList *
    gst_adapter_take_list (GstAdapter *adapter,
                           gsize nbytes);

Returns a GList of buffers containing the first `nbytes` bytes of the `adapter` . The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns returned list and contained buffers. `gst_buffer_unref()` each buffer in the list before freeing the list after usage.

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to take |

#### Returns

a GList of buffers containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available.

[element-type Gst.Buffer][transfer full][nullable]

### gst_adapter_get_list ()

    GList *
    gst_adapter_get_list (GstAdapter *adapter,
                          gsize nbytes);

Returns a GList of buffers containing the first `nbytes` bytes of the `adapter` , but does not flush them from the adapter. See `gst_adapter_take_list()` for details.

Caller owns returned list and contained buffers. `gst_buffer_unref()` each buffer in the list before freeing the list after usage.

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to get |

#### Returns

a GList of buffers containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available.

[element-type Gst.Buffer][transfer full][nullable]

Since: 1.6

### gst_adapter_take_buffer_list ()

    GstBufferList *
    gst_adapter_take_buffer_list (GstAdapter *adapter,
                                  gsize nbytes);

Returns a GstBufferList of buffers containing the first `nbytes` bytes of the `adapter` . The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns the returned list. Call `gst_buffer_list_unref()` to free the list after usage.

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to take |

#### Returns

a GstBufferList of buffers containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available.

[transfer full][nullable]

Since: 1.6

### gst_adapter_get_buffer_list ()

    GstBufferList *
    gst_adapter_get_buffer_list (GstAdapter *adapter,
                                 gsize nbytes);

Returns a GstBufferList of buffers containing the first `nbytes` bytes of the `adapter` but does not flush them from the adapter. See `gst_adapter_take_buffer_list()` for details.

Caller owns the returned list. Call `gst_buffer_list_unref()` to free the list after usage.

#### Parameters

adapter | a GstAdapter |
nbytes | the number of bytes to get |

#### Returns

a GstBufferList of buffers containing the first `nbytes` of the adapter, or `NULL` if `nbytes` bytes are not available.

[transfer full][nullable]

Since: 1.6

### gst_adapter_prev_pts ()

    GstClockTime
    gst_adapter_prev_pts (GstAdapter *adapter,
                          guint64 *distance);

Get the pts that was before the current byte in the adapter. When `distance` is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

#### Parameters

adapter | a GstAdapter |
distance | pointer to location for distance, or `NULL`. | [out][allow-none]

#### Returns

The previously seen pts.

### gst_adapter_prev_dts ()

    GstClockTime
    gst_adapter_prev_dts (GstAdapter *adapter,
                          guint64 *distance);

Get the dts that was before the current byte in the adapter. When `distance` is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

#### Parameters

adapter | a GstAdapter |
distance | pointer to location for distance, or `NULL`. | [out][allow-none]

#### Returns

The previously seen dts.

### gst_adapter_prev_pts_at_offset ()

    GstClockTime
    gst_adapter_prev_pts_at_offset (GstAdapter *adapter,
                                    gsize offset,
                                    guint64 *distance);

Get the pts that was before the byte at offset `offset` in the adapter. When `distance` is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

#### Parameters

adapter | a GstAdapter |
offset | the offset in the adapter at which to get timestamp |
distance | pointer to location for distance, or `NULL`. | [out][allow-none]

#### Returns

The previously seen pts at given offset.

Since: 1.2

### gst_adapter_prev_dts_at_offset ()

    GstClockTime
    gst_adapter_prev_dts_at_offset (GstAdapter *adapter,
                                    gsize offset,
                                    guint64 *distance);

Get the dts that was before the byte at offset `offset` in the adapter. When `distance` is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

#### Parameters

adapter | a GstAdapter |
offset | the offset in the adapter at which to get timestamp |
distance | pointer to location for distance, or `NULL`. | [out][allow-none]

#### Returns

The previously seen dts at given offset.

Since: 1.2

### gst_adapter_masked_scan_uint32 ()

    gssize
    gst_adapter_masked_scan_uint32 (GstAdapter *adapter,
                                    guint32 mask,
                                    guint32 pattern,
                                    gsize offset,
                                    gsize size);

Scan for pattern `pattern` with applied mask `mask` in the adapter data, starting from offset `offset` .

The bytes in `pattern` and `mask` are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

This function calls `gst_adapter_masked_scan_uint32_peek()` passing `NULL` for value.

#### Parameters

adapter | a GstAdapter |
mask | mask to apply to data before matching against `pattern` |
pattern | pattern to match (after mask is applied) |
offset | offset into the adapter data from which to start scanning, returns the last scanned position. |
size | number of bytes to scan from offset |

#### Returns

offset of the first match, or -1 if no match was found.

Example:

    // Assume the adapter contains 0x00 0x01 0x02 ... 0xfe 0xff
    gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 0, 256);
    // -> returns 0
    gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 1, 255);
    // -> returns -1
    gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x01020304, 1, 255);
    // -> returns 1
    gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0001, 0, 256);
    // -> returns -1
    gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0203, 0, 256);
    // -> returns 0
    gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 256);
    // -> returns 2
    gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 4);
    // -> returns -1

### gst_adapter_masked_scan_uint32_peek ()

    gssize
    gst_adapter_masked_scan_uint32_peek (GstAdapter *adapter,
                                         guint32 mask,
                                         guint32 pattern,
                                         gsize offset,
                                         gsize size,
                                         guint32 *value);

Scan for pattern `pattern` with applied mask `mask` in the adapter data, starting from offset `offset` . If a match is found, the value that matched is returned through `value` , otherwise `value` is left untouched.

The bytes in `pattern` and `mask` are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

#### Parameters

adapter | a GstAdapter |
mask | mask to apply to data before matching against `pattern` |
pattern | pattern to match (after mask is applied) |
offset | offset into the adapter data from which to start scanning, returns the last scanned position. |
size | number of bytes to scan from offset |
value | pointer to uint32 to return matching data. | [out][allow-none]

#### Returns

offset of the first match, or -1 if no match was found.

## Types and Values

### GstAdapter

    typedef struct _GstAdapter GstAdapter;

The opaque GstAdapter data structure.